<?php
$invert="no";
//$invert="yes";
$str = file_get_contents('Pliny_Nat_Hist_BOOK_XXXVII_ch_1-6_.txt');
//uni2ascii -e input.txt >output.txt to convert UTF-8 to ASCII
$pattern1 = "/[A-Za-z0-9_,-.;:?!()'\"\n]/";
$pattern2 = "/\s+/";
if($invert=="yes")
{
$image_string = preg_replace($pattern2, "0", preg_replace($pattern1, "1", $str));
}
else
{
$image_string = preg_replace($pattern2, "1", preg_replace($pattern1, "0", $str));
}
//zero out any stray characters missed by regex search string
for ($i=0;$i<strlen($image_string);$i++)
{
if ((($image_string[$i]=='1')||($image_string[$i]=='0'))==FALSE)
{
echo "Bad character = ".$image_string[$i]."\n";
$image_string[$i]=='0';
}
}
//build image array from string
$width=200;
$height= intval(strlen($image_string)/$width);
$height=$height;
$scale_factor=5;
$image_array = str_split($image_string, $width);

//open image file for writing
//first clear any existing file, then open a file for append
$image_file = fopen("texttopo.pbm", "w") or die("Unable to open file!");
$image_file = fopen("texttopo.pbm", "a") or die("Unable to open file!");
//write output image
//write header
fwrite($image_file, "P1"."\n");
fwrite($image_file, $scale_factor*200);
fwrite($image_file, " ");
//stretch y by a factor of two
fwrite($image_file, 2*$scale_factor*intval(strlen($image_string)/$width)."\n");

for ($j=0;$j<$height;$j++)
{
for ($m=0;$m<2*$scale_factor;$m++)
{
for ($i=0;$i<$width;$i++)
{
for ($k=0;$k<$scale_factor;$k++)
{
//final check of proper characters to write
if (($image_string[$i]=='1')||($image_string[$i]=='0'))
{
fwrite($image_file, $image_array[$j][$i]);
}
else
{
fwrite($image_file, '0');
}
}
}
fwrite($image_file, "\n");
}
}

fclose($image_file);
echo "Done.\n";

?>
